#include <math.h>
#include "common.h"
#include "softiic.h"

int sda_pin=0; // GPIO0
int scl_pin=1; // GPIO1
// 软件 I2C 延时
void i2c_delay() {
    delayMicroseconds(5);
}

// I2C 起始信号
void i2c_start(int sda, int scl) {
    digitalWrite(sda, HIGH);
    digitalWrite(scl, HIGH);
    i2c_delay();
    digitalWrite(sda, LOW);
    i2c_delay();
    digitalWrite(scl, LOW);
    i2c_delay();
}

// I2C 停止信号
void i2c_stop(int sda, int scl) {
    digitalWrite(sda, LOW);
    digitalWrite(scl, LOW);
    i2c_delay();
    digitalWrite(scl, HIGH);
    i2c_delay();
    digitalWrite(sda, HIGH);
    i2c_delay();
}

// I2C 发送一个字节
void i2c_write_byte(int sda, int scl, uint8_t data) {
    for (int i = 7; i >= 0; i--) {
        digitalWrite(sda, (data >> i) & 0x01);
        i2c_delay();
        digitalWrite(scl, HIGH);
        i2c_delay();
        digitalWrite(scl, LOW);
        i2c_delay();
    }
    // 接收 ACK
    pinMode(sda, INPUT);
    digitalWrite(scl, HIGH);
    i2c_delay();
    digitalWrite(scl, LOW);
    pinMode(sda, OUTPUT);
}

// I2C 读取一个字节
uint8_t i2c_read_byte(int sda, int scl, bool ack) {
    uint8_t data = 0;
    pinMode(sda, INPUT);
    for (int i = 7; i >= 0; i--) {
        digitalWrite(scl, HIGH);
        i2c_delay();
        data |= (digitalRead(sda) << i);
        digitalWrite(scl, LOW);
        i2c_delay();
    }
    // 发送 ACK/NACK
    pinMode(sda, OUTPUT);
    digitalWrite(sda, ack ? LOW : HIGH);
    digitalWrite(scl, HIGH);
    i2c_delay();
    digitalWrite(scl, LOW);
    pinMode(sda, INPUT);
    return data;
}